HDOJ 题目3466 Proud Merchants(需排序的01背包)

来源:互联网 发布:壁虎数据恢复免root版 编辑:程序博客网 时间:2024/06/05 17:18

Proud Merchants

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 2707    Accepted Submission(s): 1128


Problem Description
Recently, iSea went to an ancient country. For such a long time, it was the most wealthy and powerful kingdom in the world. As a result, the people in this country are still very proud even if their nation hasn’t been so wealthy any more.
The merchants were the most typical, each of them only sold exactly one item, the price was Pi, but they would refuse to make a trade with you if your money were less than Qi, and iSea evaluated every item a value Vi.
If he had M units of money, what’s the maximum value iSea could get?

 

Input
There are several test cases in the input.

Each test case begin with two integers N, M (1 ≤ N ≤ 500, 1 ≤ M ≤ 5000), indicating the items’ number and the initial money.
Then N lines follow, each line contains three numbers Pi, Qi and Vi (1 ≤ Pi ≤ Qi ≤ 100, 1 ≤ Vi ≤ 1000), their meaning is in the description.

The input terminates by end of file marker.

 

Output
For each test case, output one integer, indicating maximum value iSea could get.

 

Sample Input
2 1010 15 105 10 53 105 10 53 5 62 7 3
 

Sample Output
511
 

Author
iSea @ WHU
 

Source
2010 ACM-ICPC Multi-University Training Contest(3)——Host by WHU
 

Recommend
zhouzeyong   |   We have carefully selected several similar problems for you:  3460 3463 3468 3467 3465 

思路:http://blog.csdn.net/liuqiyao_01/article/details/8753708(虽然还是不大懂,县珍藏一下吧。。。。。)

题意:每个物品有p、q、v,三个属性,每个物品的话费为p,但是前提是必须有q,v则是得到的价值。

咋一看直接01就行,但是需要排序,因为如果一个物品是5 9,一个物品是5 6,对第一个进行背包的时候只有dp[9],dp[10],…,dp[m],再对第二个进行背包的时候,如果是普通的,应该会借用前面的dp[8],dp[7]之类的,但是现在这些值都是0,所以会导致结果出错。于是要想到只有后面要用的值前面都可以得到,那么才不会出错。设A:p1,q1 B:p2,q2,如果先A后B,则至少需要p1+q2的容量,如果先B后A,至少需要p2+q1的容量,那么就是p1+q2 > p2+q1,变形之后就是q1-p1 < q2-p2。

所以要针对每个属性的q-p来进行排序

 
ac代码
#include<string.h>#include<stdio.h>#include<stdlib.h>#include<algorithm>#define max(a,b) (a>b?a:b)using namespace std;struct s{int p,q,v;}b[1010];int dp[10010];int cmp(s a,s b){return a.q-a.p<b.q-b.p;}int main(){int n,m;while(scanf("%d%d",&n,&m)!=EOF){int i,j;for(i=0;i<n;i++){scanf("%d%d%d",&b[i].p,&b[i].q,&b[i].v);}sort(b,b+n,cmp);memset(dp,0,sizeof(dp));for(i=0;i<n;i++){for(j=m;j>=b[i].q;j--)//大于b[i].q{dp[j]=max(dp[j],dp[j-b[i].p]+b[i].v);}}printf("%d\n",dp[m]);}}



0 0
原创粉丝点击